#ifndef LABELLED_WIDGET_H
#define LABELLED_WIDGET_H

#include <QWidget>
#include <QLabel>
#include <QString>

template <class W>
class LabelledWidget{

    QWidget *widget;
    W *child;
    QLabel *label;

public:
    LabelledWidget(QString text = "", W *child = new W){
        QHBoxLayout *layout = new QHBoxLayout;

        this->widget = new QWidget;
        this->child = child;
        this->label = new QLabel(text);

        layout->addWidget(label);
        layout->addWidget(child);

        widget->setLayout(layout);
    }

    QWidget *getWidget(){return widget;}
    W *getChild(){return child;}
    QString getText(){return child->text();}

    void setText(QString text){label->setText(text);}

};


#endif