#include <QApplication>
#include <QWidget>
#include <QTabWidget>
#include <iostream>
#include <fstream>
#include <clocale>

#include "pcgroupbox.h"
#include "slavestab.h"
#include "mastertab.h"

#define MACHINE_LIST_PATH "machines.txt"

using namespace std;



int main(int argc, char *argv[])
{
    //Application principale
    QApplication a(argc, argv);

    std::setlocale(LC_NUMERIC,"C"); //Pour que les nombres decimaux aient des "." comme delimiteurs et pas de "," 

    QWidget w; // Fenetre

    QHBoxLayout *main_layout = new QHBoxLayout();
    QTabWidget *tabwidget = new QTabWidget; //Pages correspondant aux modes de lancement

    /*=======================================

        MODE MASTER

    =========================================
    */
    MasterTab *master_tab = new MasterTab();

	/*=======================================

		MODE SLAVES

	=========================================
	*/

    SlavesTab *slaves_tab = new SlavesTab; // Page pour le lancement en mode esclaves via ssh

    //Lecture du fichier de liste de machines
    ifstream machine_file(MACHINE_LIST_PATH);

    string line; //Stocke la ligne courante
	
	//Lecture du fichier de machines
    while(getline(machine_file,line)){
        if(!line.size()) continue; //Passe les lignes vides
        //Creation de la groupbox
        PCGroupBox *pgb = new PCGroupBox(line);
		//Ajout aux groupboxes de la page slave
        slaves_tab->addPcGroupBox(pgb);
    }



    //Ajout de la page Master
    tabwidget->addTab(master_tab, "Master");
	//Ajout de la page Slaves
    tabwidget->addTab(slaves_tab, "Slaves");
	//Ajout de l'ensemble des pages au layout de l'application
    main_layout->addWidget(tabwidget);
	//Application du layout a l'applicatrion
    w.setLayout(main_layout);
	//Que la lumiere soit
    w.show();


    return a.exec();
}
