#ifndef MASTERTAB_H
#define MASTERTAB_H


#include <QWidget>
#include <QVBoxLayout>
#include <QSpinBox>
#include <QDoubleSpinBox>
#include <QComboBox>
#include <QCheckBox>

#include "labelledwidget.h"

class MasterTab : public QWidget{
    Q_OBJECT
    QVBoxLayout *layout;
    LabelledWidget<QComboBox>
        *rom_path,
        *colour_palette;
    LabelledWidget<QCheckBox>
        *display_screen,
        *enable_sound,
        *fresh_pop;
    
    LabelledWidget<QDoubleSpinBox>
    //Floats
        *repeat_action_prob,
        *mut_rate,
        *cross_rate;
    LabelledWidget<QSpinBox> 
    //Integers
        *n_eval_p,
        *n_eval_s,
        *tourn_size,
        *pop_size,
        *nb_iter;


public:


    MasterTab();
private:
    void loadCfg();
    void saveCfg();

public slots:

};

#endif