
#include "slavestab.h"
#include "QVBoxLayout"
#include "QPushButton"
#include "QLineEdit"
#include "QLabel"
#include "QSpinBox"
#include <sstream>
#include <unistd.h>

SlavesTab::SlavesTab(QWidget *parent) : QWidget(parent)
{
    layout = new QVBoxLayout;
    groupboxes = new QHBoxLayout;

    layout->addLayout(groupboxes);

	QHBoxLayout *other_options = new QHBoxLayout;

    char hostname[256];
    gethostname(hostname,256);

	host_address = new LabelledWidget<QLineEdit>("Host Address", new QLineEdit(hostname));
    
    delay_spinner = new LabelledWidget<QSpinBox>("Delay");
    delay_spinner->getChild()->setMinimum(0);
    delay_spinner->getChild()->setMaximum(24);

	time_slave = new LabelledWidget<QSpinBox>("Time for a slave (min)");
    time_slave->getChild()->setMinimum(0);
    time_slave->getChild()->setMaximum(30);

    slaves_by_computer = new LabelledWidget<QSpinBox>("Slaves by computer");  
    slaves_by_computer->getChild()->setMinimum(1);
    slaves_by_computer->getChild()->setMaximum(16);

	QPushButton *start = new QPushButton("Start");

    QObject::connect(start,SIGNAL(clicked()),this,SLOT(print_command()));

    other_options->addWidget(delay_spinner->getWidget());
    other_options->addWidget(host_address->getWidget());
    other_options->addWidget(time_slave->getWidget());
    other_options->addWidget(slaves_by_computer->getWidget());
    other_options->addWidget(start);
    



    
    
    layout->addLayout(other_options);
    this->setLayout(layout);

}

void SlavesTab::addPcGroupBox(PCGroupBox *pgb){

    groupboxes->addWidget(pgb);
}

void SlavesTab::print_command(){

    std::stringstream command;

    command << "cd ../src && ./launch_universal.sh ";
    command << host_address->getChild()->text().toUtf8().constData()
        << " "
        << std::to_string(delay_spinner->getChild()->value())
        << " "
        << std::to_string(time_slave->getChild()->value())
        << " "
        << std::to_string(slaves_by_computer->getChild()->value());

    QList<QCheckBox *> cbs = this->findChildren<QCheckBox *>();
    int size = cbs.size();
    for(int i = 0; i<size; i++){
        if(cbs.at(i)->isChecked()){
            command << " " << (cbs.at(i)->text().toUtf8().constData());
        }
    }

    cout << endl;
    cout << command.str() << endl;

    cout << std::to_string(system(command.str().c_str())) << endl;
}


